
#define RT3052_REG(x)       (*((volatile unsigned int *)(x)))

static void udelay(unsigned long t)
{
    int i;

    while( t-- > 0 )
    {
        for(i=0;i<1000;i++)
        {
            asm volatile ("nop");
            asm volatile ("nop");
        }
    }
}

static int usbotg_host_suspend(void)
{
	unsigned int val;
	int i, rc=0, retry_count=0;
 
retry_suspend:
	val = *(volatile unsigned long *)(0xB01C0440);
	val = val >> 10;
	val = val & 0x00000003;

	if(val == 0x3)
	{
	    if(retry_count++ < 0x100000)
			goto retry_suspend;
	    return -1;
	}

	val = *(volatile unsigned long *)(0xB01C0400);
	*(volatile unsigned long *)(0xB01C0400) = (val | (1 << 2));
	//val = *(volatile unsigned long *)(0xB01C0400);
 
	val = *(volatile unsigned long *)(0xB01C0440);
	*(volatile unsigned long *)(0xB01C0440) = (val | (1 << 12));

	udelay(3000); // 3ms

	val = *(volatile unsigned long *)(0xB01C0440);
	*(volatile unsigned long *)(0xB01C0440) = (val | (1 << 8));

	udelay(10000);
	val = *(volatile unsigned long *)(0xB01C0440);
	*(volatile unsigned long *)(0xB01C0440) = (val & ~(1 << 8));

	udelay(1000);

	val = *(volatile unsigned long *)(0xB01C0440);
	val = val | (1 << 7);
	/* avoid write 1 to port enable */
	val = val & 0xFFFFFFF3;
	*(volatile unsigned long *)(0xB01C0440) = val;
	*(volatile unsigned long *)(0xB01C0E00) = 0x1;

	for(i=0; i<200000; i++)
	{
		val = *(volatile unsigned long *)(0xB01C0440);
		val = val & (1 << 7);
		if(val)
		{
			 break;   // done.
		}
		 udelay(1);
	 }

	 if(i==200000)
	 {
		 rc = -1;
	 }

	 udelay(10000);

	 *(volatile unsigned long *)(0xB0000034) = 0x00400000;
	 *(volatile unsigned long *)(0xB0000034) = 0x0;

	 udelay(20000);

	 return rc;
}

static int usbotg_device_suspend(void)
{
	unsigned int val;
	int rc = 0;

	RT3052_REG(0xB01C0E00) = 0xF;
	udelay(10000);

	RT3052_REG(0xB01C000C) = 0x40001408;    // force device mode
	udelay(5000);
 
	RT3052_REG(0xB01C0E00) = 0x1;           // stop pclock
	udelay(10000);

	val = *(volatile unsigned long *)(0xB01C0808);
	if(!(val & 0x1))
	{
		rc = -1;
	}

	RT3052_REG(0xB0000034) = 0x00400000;    // reset OTG
	RT3052_REG(0xB0000034) = 0x0;
	udelay(2000);

	return rc;
}

 

void usbotg_init(void)
{
	int i, host_rc, device_rc; 
 
	for(i=0;i<2;i++)
	{
		device_rc = usbotg_device_suspend();
		host_rc = usbotg_host_suspend();

		if(host_rc == -1 && device_rc == -1)
		{
			continue;
		} else
		{
			break;
		}
	}

	RT3052_REG(0xB01C0E00) = 0xF;        //disable USB module, optimize for power-saving
	return;
}

